//
// ⮢ ਬ   맢  ணࠬ
// ⥬ ।   stdin    stdout, stderr
// ⮩ ணࠬ.
//
//    Watcom C/C++:
// wcl386 dupstd.cpp
//
#define INCL_DOSQUEUES
#define INCL_DOSFILEMGR
#define INCL_DOSNMPIPES
#define INCL_DOSERRORS
#include <os2.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

//  ⠭ ⮪ /뢮
#define STD_IN		0
#define STD_OUT		1
#define STD_ERR		2

//    pipes
#define PIPESIZE	4096

//   pipes
HPIPE
    PipeReadHandle1, PipeWriteHandle1,
    PipeReadHandle2, PipeWriteHandle2;

//   ६  ࠭ 堭 (㡫஢) ⠭ ⮪.
// !!! 樠  -1 室 (. ᠭ 㭪樨 DosDupHandle),
// ⮡ 堭 ⠭ ⮪ ⮡ࠧ   堭, 
// ⮬   ⠭ ⠭ 堭 ⭮.
// .. ᫨  堭  ⠭,  ணࠬ ⠭
// "宩"  "᫥", ਬ  ⠭⭮ 檨 printf().
HFILE
    SavedInputHandle  =-1,
    SavedOutputHandle =-1,
    SavedErrorsHandle =-1;

//   /뢮  pipes
CHAR buf[PIPESIZE];

//
// ⢥ 楤,  믮 ७ࠢ
//  ᪠  ணࠬ   progName.
//
void runService(const CHAR *progName) {

    //  ⠭ ⮪
    HFILE
      NewHandleStdIn  = STD_IN,
      NewHandleStdOut = STD_OUT,
      NewHandleStdErr = STD_ERR;

    //   ⠭ ⮪
    //     ⮬,  ⠭ ⮪
    //   ⠭ 堭, (, ᮡ⢥,
    //  ᯮ짮  뢮   stdout 
    // த⥫᪮ ணࠬ, . )
    DosDupHandle(NewHandleStdIn,  &SavedInputHandle);
    DosDupHandle(NewHandleStdOut, &SavedOutputHandle);
    DosDupHandle(NewHandleStdErr, &SavedErrorsHandle);

    //  pipes  裡  譥 ணࠬ.
    //   ਬ  ᯮ짮 ⮫쪮  pipe,
    //   ᯮ ,  ਭ樯쭮.
    DosCreatePipe(&PipeReadHandle1, &PipeWriteHandle1, PIPESIZE);
    DosCreatePipe(&PipeReadHandle2, &PipeWriteHandle2, PIPESIZE);

    // PipeReadHandle1 - 㤥 㡫஢  stdin 譥
    // ணࠬ, .. 뢠    PipeWriteHandle1,
    //  ।    stdin 譥 ணࠬ
    DosDupHandle(PipeReadHandle1,  &NewHandleStdIn);
    // PipeWriteHandle1 - 㤥 㡫஢  stdout 譥
    // ணࠬ, ..  ᠭ  stdout ,
    //   १ PipeReadHandle2
    DosDupHandle(PipeWriteHandle2, &NewHandleStdOut);
    // stderr  stdout   뢮   堭 (祬
    //   蠥 ᮧ  pipe  ᯮ짮 )
    DosDupHandle(NewHandleStdOut,  &NewHandleStdErr);

    //   뢠 , ।  stdin cmd.exe
    // ( 襩 譥 ணࠬ).    dir,
    //  ᫥饩  exit,  室  cmd.exe
    strcpy(buf,"dir\nexit\n");

    // 뢠    PipeWriteHandle1,
    // ..  stdin 譥 ணࠬ!
    ULONG btWrited;
    DosWrite(PipeWriteHandle1,buf,strlen(buf),&btWrited);

    //  ⥪   ⮢ 楫 뢮  stdout
    // 襩 ணࠬ (த⥫᪮)
    CHAR *test = " 뢮  ࠭ த⥫᪮ ணࠬ\n\r";
    DosWrite(SavedOutputHandle,test,strlen(test),&btWrited);

    // ७ࠢ ᤥ,  뢥   ࠭ 뢠
    // ணࠬ.
    printf(" ப 뢮  ࠭  ᪠ ணࠬ,  stdout\n");

    //   ᯮ system  맮 譥 ணࠬ ⮫쪮
    //   ᠭ ਬ, , , 㤥 ᯮ짮
    // 㣨 㭪樨 (ਬ DosExecPgm)
    system(progName);

    // !  맢  ணࠬ, ࠭ ᠢ   
    // !  dir  exit, ..  ணࠬ (cmd.exe) 믮
    // !  dir, 뢥  pipe ଠ, ⥬ ,
    // ! 믮  exit. 뢥  pipe ଠ ⮢
    // !  뢠.   ᥩ  ᤥ.

    // ⠥ , 뢥  stdout  dir
    ULONG btReaded;
    DosRead(PipeReadHandle2,buf,PIPESIZE-1,&btReaded);

    if(btReaded>0) buf[btReaded] = 0;

    //  ஢ /뢮
    DosResetBuffer(STD_IN);
    DosResetBuffer(STD_OUT);
    DosResetBuffer(STD_ERR);

    //  ⠭ ⠭ stdin, stdout, stderr
    //   ࠭  砫 楤
    DosDupHandle(SavedInputHandle,  &NewHandleStdIn);
    DosDupHandle(SavedOutputHandle, &NewHandleStdOut);
    DosDupHandle(SavedErrorsHandle, &NewHandleStdErr);

    // 뢠 ,    㦭
    DosClose(PipeReadHandle1);
    DosClose(PipeWriteHandle1);
    DosClose(PipeWriteHandle2);
    DosClose(PipeReadHandle2);

    // 뢮  stdout ଠ,   稫 
    // 譥 ணࠬ.
    printf("   ⠫  pipe:\n%s\n",buf);
}

void main()
{
  runService("cmd.exe");
}
